# Mad-Assembler http://mads.atari8.info
https://atariage.com/forums/topic/179559-mads-knowledge-base/#comments

MADS is a multi-pass crossassembler designed for 6502 and 65816 processors. Binaries are generated mainly for Atari 8-bit systems (supported are AtariDosII and SpartaDOS X formats).

MADS allows using macros and procedures (ability to use program stack), division of the memory between many virtual-banks, multi-dimensional names of labels (similar to C++ and Delphi languages), local-global-temporary labels.

Max. amount of labels and macros is limited to PC's memory size. Single listing's line can be 65536 bytes long and any label can be such long as well.

# Free Pascal Compiler http://www.freepascal.org/
# Compile: fpc -Mdelphi -vh -O3 mads.pas


## Projects in Mad-Assembler

* [Infocom Z-Machine interpreter](https://github.com/jindroush/atari-inform-interpreter)
* [TurboBasic XL v1.5 disassembly](https://github.com/dmsc/turbo-dis)
* [Last Squadron](https://github.com/shanti77atari/lsquadron)
* [Commando](https://github.com/shanti77atari/commando)
* [Bosconian 5200](https://github.com/shanti77atari/bosconian5200)
* [Bosconian 128](https://github.com/shanti77atari/bosconian128)
* [Bosconian 64 PAL](https://github.com/shanti77atari/bosconian64pal)
* [Gacek VBXE](https://github.com/shanti77atari/bosconian64pal)
* [Gacek](https://github.com/shanti77atari/gacek)
* [Higway Encounter](https://github.com/shanti77atari/highway)
* [Nibbly](https://github.com/tebe6502/Nibbly)
* [Pang](https://github.com/tebe6502/Pang)
* [Getris](https://github.com/tebe6502/getris)
* [A-Maze](https://github.com/KaroLaunonen/a-maze)
* [5dots](https://gitlab.com/bocianu/5dots)
* [Raiders of the Lost Ark](https://forums.atariage.com/topic/260558-raiders-of-the-lost-ark/)
* [Pad](https://forums.atariage.com/topic/191864-pad-15-beta/?do=findComment&comment=4011355)


